package com.chinaitop.depot.intelligent.grainsituation.model;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TDcsdataExample {
    /**
     * t_dcsdata
     */
    protected String orderByClause;

    /**
     * t_dcsdata
     */
    protected boolean distinct;

    /**
     * t_dcsdata
     */
    protected List<Criteria> oredCriteria;

    public TDcsdataExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * t_dcsdata 2019-03-07
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNull() {
            addCriterion("org_id is null");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNotNull() {
            addCriterion("org_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrgIdEqualTo(String value) {
            addCriterion("org_id =", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotEqualTo(String value) {
            addCriterion("org_id <>", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThan(String value) {
            addCriterion("org_id >", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThanOrEqualTo(String value) {
            addCriterion("org_id >=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThan(String value) {
            addCriterion("org_id <", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThanOrEqualTo(String value) {
            addCriterion("org_id <=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLike(String value) {
            addCriterion("org_id like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotLike(String value) {
            addCriterion("org_id not like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdIn(List<String> values) {
            addCriterion("org_id in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotIn(List<String> values) {
            addCriterion("org_id not in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdBetween(String value1, String value2) {
            addCriterion("org_id between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotBetween(String value1, String value2) {
            addCriterion("org_id not between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andVDcsCodeIsNull() {
            addCriterion("v_dcs_code is null");
            return (Criteria) this;
        }

        public Criteria andVDcsCodeIsNotNull() {
            addCriterion("v_dcs_code is not null");
            return (Criteria) this;
        }

        public Criteria andVDcsCodeEqualTo(String value) {
            addCriterion("v_dcs_code =", value, "vDcsCode");
            return (Criteria) this;
        }

        public Criteria andVDcsCodeNotEqualTo(String value) {
            addCriterion("v_dcs_code <>", value, "vDcsCode");
            return (Criteria) this;
        }

        public Criteria andVDcsCodeGreaterThan(String value) {
            addCriterion("v_dcs_code >", value, "vDcsCode");
            return (Criteria) this;
        }

        public Criteria andVDcsCodeGreaterThanOrEqualTo(String value) {
            addCriterion("v_dcs_code >=", value, "vDcsCode");
            return (Criteria) this;
        }

        public Criteria andVDcsCodeLessThan(String value) {
            addCriterion("v_dcs_code <", value, "vDcsCode");
            return (Criteria) this;
        }

        public Criteria andVDcsCodeLessThanOrEqualTo(String value) {
            addCriterion("v_dcs_code <=", value, "vDcsCode");
            return (Criteria) this;
        }

        public Criteria andVDcsCodeLike(String value) {
            addCriterion("v_dcs_code like", value, "vDcsCode");
            return (Criteria) this;
        }

        public Criteria andVDcsCodeNotLike(String value) {
            addCriterion("v_dcs_code not like", value, "vDcsCode");
            return (Criteria) this;
        }

        public Criteria andVDcsCodeIn(List<String> values) {
            addCriterion("v_dcs_code in", values, "vDcsCode");
            return (Criteria) this;
        }

        public Criteria andVDcsCodeNotIn(List<String> values) {
            addCriterion("v_dcs_code not in", values, "vDcsCode");
            return (Criteria) this;
        }

        public Criteria andVDcsCodeBetween(String value1, String value2) {
            addCriterion("v_dcs_code between", value1, value2, "vDcsCode");
            return (Criteria) this;
        }

        public Criteria andVDcsCodeNotBetween(String value1, String value2) {
            addCriterion("v_dcs_code not between", value1, value2, "vDcsCode");
            return (Criteria) this;
        }

        public Criteria andITdhIsNull() {
            addCriterion("i_tdh is null");
            return (Criteria) this;
        }

        public Criteria andITdhIsNotNull() {
            addCriterion("i_tdh is not null");
            return (Criteria) this;
        }

        public Criteria andITdhEqualTo(Integer value) {
            addCriterion("i_tdh =", value, "iTdh");
            return (Criteria) this;
        }

        public Criteria andITdhNotEqualTo(Integer value) {
            addCriterion("i_tdh <>", value, "iTdh");
            return (Criteria) this;
        }

        public Criteria andITdhGreaterThan(Integer value) {
            addCriterion("i_tdh >", value, "iTdh");
            return (Criteria) this;
        }

        public Criteria andITdhGreaterThanOrEqualTo(Integer value) {
            addCriterion("i_tdh >=", value, "iTdh");
            return (Criteria) this;
        }

        public Criteria andITdhLessThan(Integer value) {
            addCriterion("i_tdh <", value, "iTdh");
            return (Criteria) this;
        }

        public Criteria andITdhLessThanOrEqualTo(Integer value) {
            addCriterion("i_tdh <=", value, "iTdh");
            return (Criteria) this;
        }

        public Criteria andITdhIn(List<Integer> values) {
            addCriterion("i_tdh in", values, "iTdh");
            return (Criteria) this;
        }

        public Criteria andITdhNotIn(List<Integer> values) {
            addCriterion("i_tdh not in", values, "iTdh");
            return (Criteria) this;
        }

        public Criteria andITdhBetween(Integer value1, Integer value2) {
            addCriterion("i_tdh between", value1, value2, "iTdh");
            return (Criteria) this;
        }

        public Criteria andITdhNotBetween(Integer value1, Integer value2) {
            addCriterion("i_tdh not between", value1, value2, "iTdh");
            return (Criteria) this;
        }

        public Criteria andIValueIsNull() {
            addCriterion("i_value is null");
            return (Criteria) this;
        }

        public Criteria andIValueIsNotNull() {
            addCriterion("i_value is not null");
            return (Criteria) this;
        }

        public Criteria andIValueEqualTo(BigDecimal value) {
            addCriterion("i_value =", value, "iValue");
            return (Criteria) this;
        }

        public Criteria andIValueNotEqualTo(BigDecimal value) {
            addCriterion("i_value <>", value, "iValue");
            return (Criteria) this;
        }

        public Criteria andIValueGreaterThan(BigDecimal value) {
            addCriterion("i_value >", value, "iValue");
            return (Criteria) this;
        }

        public Criteria andIValueGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("i_value >=", value, "iValue");
            return (Criteria) this;
        }

        public Criteria andIValueLessThan(BigDecimal value) {
            addCriterion("i_value <", value, "iValue");
            return (Criteria) this;
        }

        public Criteria andIValueLessThanOrEqualTo(BigDecimal value) {
            addCriterion("i_value <=", value, "iValue");
            return (Criteria) this;
        }

        public Criteria andIValueIn(List<BigDecimal> values) {
            addCriterion("i_value in", values, "iValue");
            return (Criteria) this;
        }

        public Criteria andIValueNotIn(List<BigDecimal> values) {
            addCriterion("i_value not in", values, "iValue");
            return (Criteria) this;
        }

        public Criteria andIValueBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("i_value between", value1, value2, "iValue");
            return (Criteria) this;
        }

        public Criteria andIValueNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("i_value not between", value1, value2, "iValue");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeIsNull() {
            addCriterion("v_dev_kind_code is null");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeIsNotNull() {
            addCriterion("v_dev_kind_code is not null");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeEqualTo(String value) {
            addCriterion("v_dev_kind_code =", value, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeNotEqualTo(String value) {
            addCriterion("v_dev_kind_code <>", value, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeGreaterThan(String value) {
            addCriterion("v_dev_kind_code >", value, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeGreaterThanOrEqualTo(String value) {
            addCriterion("v_dev_kind_code >=", value, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeLessThan(String value) {
            addCriterion("v_dev_kind_code <", value, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeLessThanOrEqualTo(String value) {
            addCriterion("v_dev_kind_code <=", value, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeLike(String value) {
            addCriterion("v_dev_kind_code like", value, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeNotLike(String value) {
            addCriterion("v_dev_kind_code not like", value, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeIn(List<String> values) {
            addCriterion("v_dev_kind_code in", values, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeNotIn(List<String> values) {
            addCriterion("v_dev_kind_code not in", values, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeBetween(String value1, String value2) {
            addCriterion("v_dev_kind_code between", value1, value2, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeNotBetween(String value1, String value2) {
            addCriterion("v_dev_kind_code not between", value1, value2, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeIsNull() {
            addCriterion("v_update_time is null");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeIsNotNull() {
            addCriterion("v_update_time is not null");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeEqualTo(Date value) {
            addCriterion("v_update_time =", value, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeNotEqualTo(Date value) {
            addCriterion("v_update_time <>", value, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeGreaterThan(Date value) {
            addCriterion("v_update_time >", value, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("v_update_time >=", value, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeLessThan(Date value) {
            addCriterion("v_update_time <", value, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("v_update_time <=", value, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeIn(List<Date> values) {
            addCriterion("v_update_time in", values, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeNotIn(List<Date> values) {
            addCriterion("v_update_time not in", values, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("v_update_time between", value1, value2, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("v_update_time not between", value1, value2, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNull() {
            addCriterion("data_source is null");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNotNull() {
            addCriterion("data_source is not null");
            return (Criteria) this;
        }

        public Criteria andDataSourceEqualTo(String value) {
            addCriterion("data_source =", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotEqualTo(String value) {
            addCriterion("data_source <>", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThan(String value) {
            addCriterion("data_source >", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThanOrEqualTo(String value) {
            addCriterion("data_source >=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThan(String value) {
            addCriterion("data_source <", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThanOrEqualTo(String value) {
            addCriterion("data_source <=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLike(String value) {
            addCriterion("data_source like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotLike(String value) {
            addCriterion("data_source not like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceIn(List<String> values) {
            addCriterion("data_source in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotIn(List<String> values) {
            addCriterion("data_source not in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceBetween(String value1, String value2) {
            addCriterion("data_source between", value1, value2, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotBetween(String value1, String value2) {
            addCriterion("data_source not between", value1, value2, "dataSource");
            return (Criteria) this;
        }

        public Criteria andVRemarkIsNull() {
            addCriterion("v_remark is null");
            return (Criteria) this;
        }

        public Criteria andVRemarkIsNotNull() {
            addCriterion("v_remark is not null");
            return (Criteria) this;
        }

        public Criteria andVRemarkEqualTo(String value) {
            addCriterion("v_remark =", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkNotEqualTo(String value) {
            addCriterion("v_remark <>", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkGreaterThan(String value) {
            addCriterion("v_remark >", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("v_remark >=", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkLessThan(String value) {
            addCriterion("v_remark <", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkLessThanOrEqualTo(String value) {
            addCriterion("v_remark <=", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkLike(String value) {
            addCriterion("v_remark like", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkNotLike(String value) {
            addCriterion("v_remark not like", value, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkIn(List<String> values) {
            addCriterion("v_remark in", values, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkNotIn(List<String> values) {
            addCriterion("v_remark not in", values, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkBetween(String value1, String value2) {
            addCriterion("v_remark between", value1, value2, "vRemark");
            return (Criteria) this;
        }

        public Criteria andVRemarkNotBetween(String value1, String value2) {
            addCriterion("v_remark not between", value1, value2, "vRemark");
            return (Criteria) this;
        }
    }

    /**
     * t_dcsdata
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * t_dcsdata 2019-03-07
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}